package com.documentscanner.views;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.widget.FrameLayout;

import com.documentscanner.R;

/**
 * Created by andre on 09/01/2018.
 */

public class MainView extends FrameLayout {
    private OpenNoteCameraView view;

    public MainView(Context context, Activity activity) {
        super(context);

        LayoutInflater lf = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        FrameLayout frameLayout = (FrameLayout) lf.inflate(R.layout.activity_open_note_scanner, null);

        view = new OpenNoteCameraView(context, -1, activity, frameLayout);
        addViewInLayout(view, 0, new FrameLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
        addViewInLayout(frameLayout, 1, view.getLayoutParams());
    }

    @Override
    protected void onLayout(boolean changed, int l, int t, int r, int b) {
        for (int i = 0; i < getChildCount(); i++) {
            getChildAt(i).layout(l, t, r, b);
        }
    }

    public void setDetectionCountBeforeCapture(int numberOfRectangles) {
        view.setDetectionCountBeforeCapture(numberOfRectangles);
    }

    public void setDurationBetweenCaptures(double durationBetweenCaptures) {
        view.setDurationBetweenCaptures(durationBetweenCaptures);
    }

    public void setEnableTorch(boolean enable) {
        view.setEnableTorch(enable);
    }

    public void setOnScannerListener(OpenNoteCameraView.OnScannerListener listener) {
        view.setOnScannerListener(listener);
    }

    public void setOnProcessingListener(OpenNoteCameraView.OnProcessingListener listener) {
        view.setOnProcessingListener(listener);
    }

    public void setOverlayColor(String rgbaColor) {
        view.setOverlayColor(rgbaColor);
    }

    public void setSaveOnDevice(Boolean saveOnDevice) {
        view.setSaveOnDevice(saveOnDevice);
    }

    public void setBrightness(double brightness) {
        view.setBrightness(brightness);
    }

    public void setContrast(double contrast) {
        view.setContrast(contrast);
    }

    public void setManualOnly(boolean manualOnly) {
        view.setManualOnly(manualOnly);
    }

    public void capture() {
        view.capture();
    }
}
